unit testmain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, sip, Buttons, mmSystem;

type
  TForm1 = class(TForm)
    SIPSession1: TSIPSession;
    SIPLine1: TSIPLine;
    Memo1: TMemo;
    GroupBox1: TGroupBox;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    ServerIPEdit: TEdit;
    UserNameEdit: TEdit;
    PasswordEdit: TEdit;
    GroupBox2: TGroupBox;
    Label1: TLabel;
    PhoneNumberEdit: TEdit;
    CallBtn: TBitBtn;
    HangUpBtn: TBitBtn;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    SpeedButton4: TSpeedButton;
    SpeedButton5: TSpeedButton;
    SpeedButton6: TSpeedButton;
    SpeedButton7: TSpeedButton;
    SpeedButton8: TSpeedButton;
    SpeedButton9: TSpeedButton;
    SpeedButton10: TSpeedButton;
    SpeedButton11: TSpeedButton;
    SpeedButton12: TSpeedButton;
    RegisterButton: TBitBtn;
    UnregisterButton: TBitBtn;
    Label6: TLabel;
    WavFileNameEdit: TEdit;
    PlayBtn: TButton;
    SpeakersEnabled: TCheckBox;
    MicrophoneEnabled: TCheckBox;
    LocalPortEdit: TEdit;
    Label5: TLabel;
    SpeechBtn: TButton;
    SpeechEdit: TEdit;
    Label7: TLabel;
    VoiceBox: TComboBox;
    Label8: TLabel;
    procedure RegisterButtonClick(Sender: TObject);
    procedure UnRegisterButtonClick(Sender: TObject);
    procedure SIPSession1Registered(Sender: TObject);
    procedure SIPSession1UnRegistered(Sender: TObject);
    procedure SIPSession1Error(Sender: TObject);
    procedure CallBtnClick(Sender: TObject);
    procedure HangUpBtnClick(Sender: TObject);
    procedure SIPLine1Answer(Sender: TObject);
    procedure SIPLine1HangUp(Sender: TObject);
    procedure SIPLine1Error(Sender: TObject);
    procedure SIPLine1PlayCompleted(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure SIPLine1DTMF(Sender: TObject; const DTMF: String);
    procedure SIPSession1Invite(Sender: TObject; const FriendlyName,
      CallID, Packet: String);
    procedure SIPSession1Cancel(Sender: TObject; const CallID: String);
    procedure SpeedButton1Click(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure SpeakersEnabledClick(Sender: TObject);
    procedure MicrophoneEnabledClick(Sender: TObject);
    procedure PlayBtnClick(Sender: TObject);
    procedure SpeechBtnClick(Sender: TObject);
    procedure VoiceBoxChange(Sender: TObject);
  private
    procedure SaveParams;
    procedure LoadParams;
  public
    InvitePacket: String;
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses IniFiles;

procedure TForm1.SaveParams;
var
  Ini: TIniFile;
begin
  Ini := TIniFile.Create(ExtractFilePath(ParamStr(0))+'\siptest.ini');
  try
    Ini.WriteString('Account', 'ServerIP', ServerIPEdit.Text);
    Ini.WriteString('Account', 'UserName', UserNameEdit.Text);
    Ini.WriteString('Account', 'Password', PasswordEdit.Text);
    Ini.WriteString('Line', 'PhoneNumber', PhoneNumberEdit.Text);
    Ini.WriteString('Session', 'LocalPort', LocalPortEdit.Text);
  finally
    Ini.Free;
  end;
end;

procedure TForm1.LoadParams;
var
  Ini: TIniFile;
begin
  Ini := TIniFile.Create(ExtractFilePath(ParamStr(0))+'\siptest.ini');
  try
    ServerIPEdit.Text := Ini.ReadString('Account', 'ServerIP', '');
    UserNameEdit.Text := Ini.ReadString('Account', 'UserName', '');
    PasswordEdit.Text := Ini.ReadString('Account', 'Password', '');
    PhoneNumberEdit.Text := Ini.ReadString('Line', 'PhoneNumber', '');
    LocalPortEdit.Text := Ini.ReadString('Session', 'LocalPort', '5072');
  finally
    Ini.Free;
  end;
end;


procedure TForm1.RegisterButtonClick(Sender: TObject);
begin
  SaveParams;
  RegisterButton.Enabled := False;
  SIPSession1.ServerIP := ServerIPEdit.Text;
  SIPSession1.UserName := UserNameEdit.Text;
  SIPSession1.Password := PasswordEdit.Text;
  SIPSession1.LocalPort := LocalPortEdit.Text;
  SIPSession1.Register(10000);
end;

procedure TForm1.UnRegisterButtonClick(Sender: TObject);
begin
  UnRegisterButton.Enabled := False;
  SIPSession1.UnRegister(5000);
end;

procedure TForm1.SIPSession1Registered(Sender: TObject);
begin
  RegisterButton.Enabled := False;
  UnRegisterButton.Enabled := True;
  CallBtn.Enabled := SIPSession1.Registered and not SIPLine1.Active;
  HangUpBtn.Enabled := SIPSession1.Registered and SIPLine1.Active;
  Memo1.Lines.Add('successfully registered on '+SIPSession1.ServerIP+' ( username is '+SIPSession1.UserName+')');
end;

procedure TForm1.SIPSession1UnRegistered(Sender: TObject);
begin
  RegisterButton.Enabled := True;
  UnRegisterButton.Enabled := False;
  CallBtn.Enabled := SIPSession1.Registered and not SIPLine1.Active;
  HangUpBtn.Enabled := SIPSession1.Registered and SIPLine1.Active;
  Memo1.Lines.Add('unregistered from '+SIPSession1.ServerIP);
end;

procedure TForm1.SIPSession1Error(Sender: TObject);
begin
  RegisterButton.Enabled := True;
  UnRegisterButton.Enabled := False;
  CallBtn.Enabled := SIPSession1.Registered and not SIPLine1.Active;
  HangUpBtn.Enabled := SIPSession1.Registered and SIPLine1.Active;
  Memo1.Lines.Add('error registering on '+SIPSession1.ServerIP);
end;

procedure TForm1.CallBtnClick(Sender: TObject);
begin
  SaveParams;
  CallBtn.Enabled := False;
  if InvitePacket <> '' then
  begin
    SIPSession1.Accept(SIPLine1, InvitePacket);
    Memo1.Lines.Add('call from '+CallBtn.Hint+' accepted...');
    InvitePacket := '';
    HangUpBtn.Enabled := True;
  end else
  begin
    SIPLine1.PhoneNumber := PhoneNumberEdit.Text;
    Memo1.Lines.Add('calling the user/phone number: '+SIPLine1.PhoneNumber);
    SIPLine1.Call;
  end;
end;

procedure TForm1.HangUpBtnClick(Sender: TObject);
begin
  HangUpBtn.Enabled := False;
  if InvitePacket <> '' then
  begin
    SIPSession1.Decline(InvitePacket);
    InvitePacket := '';
    CallBtn.ShowHint := False; 
    CallBtn.Hint := '';
  end
  else SIPLine1.HangUp;
end;

procedure TForm1.SIPLine1Answer(Sender: TObject);
begin
  HangUpBtn.Enabled := True;
  Memo1.Lines.Add('user (phone number) '+TSIPLine(Sender).PhoneNumber+' answered the call...');
end;

procedure TForm1.SIPLine1HangUp(Sender: TObject);
begin
  CallBtn.Enabled := True;
  HangUpBtn.Enabled := False;
  Memo1.Lines.Add('disconnected from '+TSIPLine(Sender).PhoneNumber);
end;

procedure TForm1.SIPLine1Error(Sender: TObject);
begin
  CallBtn.Enabled := True;
  HangUpBtn.Enabled := False;
  Memo1.Lines.Add('call to '+TSIPLine(Sender).PhoneNumber+ ' failed');
end;

procedure TForm1.SIPLine1PlayCompleted(Sender: TObject);
begin
  Memo1.Lines.Add('playing finished');
end;

procedure TForm1.FormShow(Sender: TObject);
var
  cnt, i: Integer;
begin
  LoadParams;
  cnt := GetVoicesCount;
  for i := 0 to cnt - 1 do VoiceBox.Items.Add(GetVoiceName(i));
  if VoiceBox.Items.Count > 0 then
    VoiceBox.ItemIndex := 0;
end;

procedure TForm1.SIPLine1DTMF(Sender: TObject; const DTMF: String);
begin
  Memo1.Lines.Add('DTMF (user input): '+DTMF);
end;

procedure TForm1.SIPSession1Invite(Sender: TObject; const FriendlyName,
  CallID, Packet: String);
begin
  Memo1.Lines.Add('incoming call from: '+FriendlyName);
  InvitePacket := Packet;
  CallBtn.Hint := FriendlyName;
  CallBtn.ShowHint := True;
  if CallBtn.CanFocus then
    CallBtn.SetFocus;
  HangUpBtn.Enabled := True;
end;

procedure TForm1.SIPSession1Cancel(Sender: TObject; const CallID: String);
begin
  if InvitePacket <> '' then
  begin
    InvitePacket := '';
    CallBtn.Hint := '';
    CallBtn.ShowHint := False;
    HangUpBtn.Enabled := False;
    Memo1.Lines.Add('incoming call cancelled '+CallID);
  end;
end;

procedure TForm1.SpeedButton1Click(Sender: TObject);
begin
  PhoneNumberEdit.Text := PhoneNumberEdit.Text + TSpeedButton(Sender).Caption;
end;

procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  SIPSession1.Free;
  CanClose := True;
end;

procedure TForm1.SpeakersEnabledClick(Sender: TObject);
begin
  SIPLine1.SpeakersEnabled := SpeakersEnabled.Checked;
end;

procedure TForm1.MicrophoneEnabledClick(Sender: TObject);
begin
  SIPLine1.MicrophoneEnabled := MicrophoneEnabled.Checked;
end;

procedure TForm1.PlayBtnClick(Sender: TObject);
begin
  if SIPLine1.Connected then
    SIPLine1.PlayWavFile(WavFileNameEdit.Text);
end;

procedure TForm1.SpeechBtnClick(Sender: TObject);
begin
  if SIPLine1.Connected then
    SIPLine1.PlayText(SpeechEdit.Text);
end;

procedure TForm1.VoiceBoxChange(Sender: TObject);
begin
  SIPLine1.VoiceIndex := VoiceBox.ItemIndex;
end;

end.
